searchData={"items":[{"type":"module","title":"EctoWatch","doc":"A library to allow you to easily get notifications about database changes directly from PostgreSQL.","ref":"EctoWatch.html"},{"type":"function","title":"EctoWatch.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"EctoWatch.html#child_spec/1"},{"type":"function","title":"EctoWatch.init/1","doc":"","ref":"EctoWatch.html#init/1"},{"type":"function","title":"EctoWatch.start_link/1","doc":"","ref":"EctoWatch.html#start_link/1"},{"type":"function","title":"EctoWatch.subscribe/2","doc":"Subscribe to notifications from watchers.\n\nExamples:\n\n    iex> EctoWatch.subscribe({Comment, :updated})\n\n  When subscribing to a watcher with the `label` option specified as `:comment_updated_custom`:\n\n    iex> EctoWatch.subscribe(:comment_updated_custom)\n\n  You can subscribe to notifications just from specific primary key values:\n\n    iex> EctoWatch.subscribe({Comment, :updated}, user_id)\n\n  Or you can subscribe to notifications just from a specific foreign column (**the column must be in the watcher's `extra_columns` list):\n\n    iex> EctoWatch.subscribe({Comment, :updated}, {:post_id, post_id})","ref":"EctoWatch.html#subscribe/2"},{"type":"function","title":"EctoWatch.subscribe/3","doc":"","ref":"EctoWatch.html#subscribe/3"},{"type":"type","title":"EctoWatch.watcher_identifier/0","doc":"","ref":"EctoWatch.html#t:watcher_identifier/0"},{"type":"module","title":"EctoWatch.WatcherServer","doc":"Internal GenServer for the individiual change watchers which are configured by end users\n\nUsed internally, but you'll see it in your application supervision tree.","ref":"EctoWatch.WatcherServer.html"},{"type":"function","title":"EctoWatch.WatcherServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"EctoWatch.WatcherServer.html#child_spec/1"},{"type":"function","title":"EctoWatch.WatcherServer.details/1","doc":"","ref":"EctoWatch.WatcherServer.html#details/1"},{"type":"function","title":"EctoWatch.WatcherServer.init/1","doc":"","ref":"EctoWatch.WatcherServer.html#init/1"},{"type":"function","title":"EctoWatch.WatcherServer.name/1","doc":"","ref":"EctoWatch.WatcherServer.html#name/1"},{"type":"function","title":"EctoWatch.WatcherServer.pub_sub_subscription_details/2","doc":"","ref":"EctoWatch.WatcherServer.html#pub_sub_subscription_details/2"},{"type":"function","title":"EctoWatch.WatcherServer.start_link/1","doc":"","ref":"EctoWatch.WatcherServer.html#start_link/1"},{"type":"function","title":"EctoWatch.WatcherServer.topics/4","doc":"","ref":"EctoWatch.WatcherServer.html#topics/4"},{"type":"function","title":"EctoWatch.WatcherServer.watcher_details/0","doc":"","ref":"EctoWatch.WatcherServer.html#watcher_details/0"},{"type":"module","title":"EctoWatch.WatcherSupervisor","doc":"Internal Supervisor for postgres notification watchers (`EctoWatch.WatcherServer`)\n\nUsed internally, but you'll see it in your application supervision tree.","ref":"EctoWatch.WatcherSupervisor.html"},{"type":"function","title":"EctoWatch.WatcherSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"EctoWatch.WatcherSupervisor.html#child_spec/1"},{"type":"function","title":"EctoWatch.WatcherSupervisor.init/1","doc":"","ref":"EctoWatch.WatcherSupervisor.html#init/1"},{"type":"function","title":"EctoWatch.WatcherSupervisor.start_link/1","doc":"","ref":"EctoWatch.WatcherSupervisor.html#start_link/1"},{"type":"module","title":"EctoWatch.WatcherTriggerValidator","doc":"Intenal task run as part of the EctoWatch supervision tree to check for a match between the triggers\nthat are in the database and the triggers that were started via the configuration.\n\nUsed internally, but you'll see it in your application supervision tree.","ref":"EctoWatch.WatcherTriggerValidator.html"},{"type":"function","title":"EctoWatch.WatcherTriggerValidator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"EctoWatch.WatcherTriggerValidator.html#child_spec/1"},{"type":"function","title":"EctoWatch.WatcherTriggerValidator.find_functions/1","doc":"","ref":"EctoWatch.WatcherTriggerValidator.html#find_functions/1"},{"type":"function","title":"EctoWatch.WatcherTriggerValidator.run/1","doc":"","ref":"EctoWatch.WatcherTriggerValidator.html#run/1"},{"type":"function","title":"EctoWatch.WatcherTriggerValidator.start_link/1","doc":"","ref":"EctoWatch.WatcherTriggerValidator.html#start_link/1"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.1.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n**IMPORTANT NOTE**: Make sure to see the [Upgrading Versions](guides/howtos/Upgrading Versions.md) guide in the [HexDocs documentation](https://hexdocs.pm/ecto_watch) if you're having an issue after upgrading.\n\n## [0.9.5] - 2023-08-08","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Add validation errors for when watchers are created which can't be disambiguated\n\n## [0.9.4] - 2023-08-08","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Documentation release\n\n## [0.9.3] - 2023-08-08","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Documentation release\n\n## [0.9.2] - 2023-08-08","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Documentation release\n\n## [0.9.1] - 2023-08-08","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Documentation release\n\n## [0.9.0] - 2023-08-07","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Warnings when there are extra triggers / function in the database\n- Support for auto-deleting triggers and functions when the `ECTO_WATCH_CLEANUP` environment variable is set to `cleanup`\n\n## [0.8.1] - 2023-08-07","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Add detail to exception for more helpful info on the change in messages\n\n## [0.8.0] - 2023-08-07","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- BREAKING: Don't require specifying update type for watchers with labels (#19)","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Allow watchers without an ecto schema (thanks @frerich / #18)\n\n## [0.7.0] - 2023-07-31","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Allow empty watcher list (thanks @barrelltech / #14)\n\n## [0.6.0] - 2023-07-30","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Support for subscribing to association column values (thanks @barrelltech / #6)","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Changed broadcast messages from a 4-element tuple to a 3-element tuple (see #12 / thanks @venkatd + @barrelltech)\n\n## [0.5.4] - 2023-07-18","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Backwards compatibility with older versions of postgres that don't support the `OR REPLACE` clause in `CREATE TRIGGER` (thanks @adampash / #10)\n\n## [0.5.3] - 2023-07-12","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Support primary keys other than `id` (thanks @venkatd / #3)\n\n## [0.5.1] - 2023-07-02","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Use quotes around table name in trigger to allow for special characters\n\n## [0.5.0] - 2023-07-02","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Support for ecto's `@schema_prefix`","ref":"changelog.html#fixed"},{"type":"extras","title":"Getting Started","doc":"To use EctoWatch, you need to add it to your supervision tree and specify watchers for Ecto schemas and update types.  It would look something like this in your `application.ex` file (after `MyApp.Repo` and `MyApp.PubSub`):\n\n```elixir\n  alias MyApp.Accounts.User\n  alias MyApp.Accounts.Package\n\n  {EctoWatch,\n   repo: MyApp.Repo,\n   pub_sub: MyApp.PubSub,\n   watchers: [\n     {User, :inserted},\n     {User, :updated},\n     {User, :deleted},\n     {Package, :inserted},\n     {Package, :updated}\n   ]}\n```\n\nThis will setup:\n\n * triggers in PostgreSQL during application startup\n * an Elixir process for each watcher which listens for notifications and broadcasts them via `Phoenix.PubSub`\n\nThen any process (e.g. a GenServer, a LiveView, a Phoenix channel, etc...) can subscribe to messages like so:\n\n```elixir\n  EctoWatch.subscribe({User, :inserted})\n  EctoWatch.subscribe({User, :updated})\n  EctoWatch.subscribe({User, :deleted})\n\n  EctoWatch.subscribe({Package, :inserted})\n  EctoWatch.subscribe({Package, :updated})\n```\n\n(note that if you are subscribing in a LiveView `mount` callback you should subscribe inside of a `if connected?(socket) do` to avoid subscribing twice).\n\nYou can also subscribe to individual records:\n\n```elixir\n  EctoWatch.subscribe({User, :updated}, user.id)\n  EctoWatch.subscribe({User, :deleted}, user.id)\n```\n\n... OR you can subscribe to records by an association column (but the given column must be in the `extra_columns` list for the watcher! See below for more info on the `extra_columns` option):\n\n```elixir\n  EctoWatch.subscribe({User, :updated}, {:role_id, role.id})\n  EctoWatch.subscribe({User, :deleted}, {:role_id, role.id})\n```\n\nOnce subscribed, messages can be handled like so (LiveView example are given here but `handle_info` callbacks can be used elsewhere as well):\n\n```elixir\n  def handle_info({{User, :inserted}, %{id: id}}, socket) do\n    user = Accounts.get_user(id)\n    socket = stream_insert(socket, :users, user)\n\n    {:noreply, socket}\n  end\n\n  def handle_info({{User, :updated}, %{id: id}}, socket) do\n    user = Accounts.get_user(id)\n    socket = stream_insert(socket, :users, user)\n\n    {:noreply, socket}\n  end\n\n  def handle_info({{User, :deleted}, %{id: id}}, socket) do\n    socket = stream_delete_by_dom_id(socket, :songs, \"users-#{id}\")\n\n    {:noreply, socket}\n  end\n```","ref":"getting-started.html"},{"type":"extras","title":"Tracking columns and using labels","doc":"You can also setup the database to trigger only on specific column changes on `:updated` watchers.  When doing this a `label` required:\n\n```elixir\n  # setup\n  {EctoWatch,\n   repo: MyApp.Repo,\n   pub_sub: MyApp.PubSub,\n   watchers: [\n     # ...\n     {User, :updated, trigger_columns: [:email, :phone], label: :user_contact_info_updated},\n     # ...\n   ]}\n\n  # subscribing\n  EctoWatch.subscribe(:user_contact_info_updated)\n  # or...\n  EctoWatch.subscribe(:user_contact_info_updated, package.id)\n  # or...\n  EctoWatch.subscribe(:user_contact_info_updated, {:role_id, role_id})\n\n  # handling messages\n  def handle_info({:user_contact_info_updated, %{id: id}}, socket) do\n```\n\nA label is required for two reasons:\n\n * When handling the message it makes it clear that the message isn't for general schema updates but is for specific columns\n * The same schema can be watched for different sets of columns, so the label is used to differentiate between them.\n\nYou can also use labels in general without tracking specific columns:\n\n```elixir\n  # setup\n  {EctoWatch,\n   repo: MyApp.Repo,\n   pub_sub: MyApp.PubSub,\n   watchers: [\n     # ...\n     {User, :updated, label: :user_update},\n     # ...\n   ]}\n\n  # subscribing\n  EctoWatch.subscribe(:user_update)\n  # or...\n  EctoWatch.subscribe(:user_update, package.id)\n  # or...\n  EctoWatch.subscribe(:user_update, {:role_id, role_id})\n\n  # handling messages\n  def handle_info({:user_update, %{id: id}}, socket) do\n```","ref":"tracking-columns-and-using-labels.html"},{"type":"extras","title":"Getting additional values","doc":"If you would like to get more than just the `id` from the record, you can use the `extra_columns` option.\n\n> The `extra_columns` option should be used with care because:\n> \n>  * The `pg_notify` function has a limit of 8000 characters and wasn't created to send full-records on updates.\n>  * If many updates are done in quick succession to the same record, subscribers will need to process all of the old results before getting to the newest one.\n>\n> Thus using `extra_columns` with columns that change often may not be what you want.\n>\n> One use-case where using `extra_columns` may be particularly useful is if you want to receive updates about the deletion of a record and you need to know one of it's foreign keys.  E.g. in a blog, if a `Comment` is deleted you might want to get the `post_id` to refresh any caches related to comments.\n\n```elixir\n  # setup\n  {EctoWatch,\n   repo: MyApp.Repo,\n   pub_sub: MyApp.PubSub,\n   watchers: [\n     # ...\n     {Comment, :deleted, extra_columns: [:post_id]},\n     # ...\n   ]}\n\n  # subscribing\n  EctoWatch.subscribe({Comment, :deleted})\n\n  # handling messages\n  def handle_info({{Comment, :deleted}, %{id: id, post_id: post_id}}, socket) do\n    Posts.refresh_cache(post_id)\n\n    # ...\n```","ref":"getting-additional-values.html"},{"type":"extras","title":"Watching without a schema","doc":"Since ecto supports working with tables withoun needed a schema, you may also want to create EctoWatch watchers without needing to create a schema like so:\n\n```elixir\n  # setup\n  {EctoWatch,\n   repo: MyApp.Repo,\n   pub_sub: MyApp.PubSub,\n   watchers: [\n    {\n      %{\n        table_name: \"comments\",\n        primary_key: :ID,\n        columns: [:title, :body, :author_id, :post_id],\n        association_columns: [:author_id, :post_id]\n      }, :updated, extra_columns: [:post_id]\n    }\n   ]}\n```\n\nEverything works the same as with a schema, though make sure to specify your association columns if you want to subscribe to an association column.\n\nSupported keys for configuring a table without a schema:\n\n * `schema_prefix` (optional, defaults to `public`)\n * `table_name` (required)\n * `primary_key` (optional, defaults to `id`)\n * `columns` (optional, defaults to `[]`)\n * `association_columns` (optional, defaults to `[]`)","ref":"watching-without-a-schema.html"},{"type":"extras","title":"Notes","doc":"","ref":"notes.html"},{"type":"extras","title":"Dealing with leftover PostgreSQL triggers - Notes","doc":"Because of the nature of delegating to a trigger in PostgreSQL, you can end up with leftover triggers and functions in the database (e.g. if you remove a watcher or change a watcher's label).  If you have `EctoWatch` in your application tree (even with an empty list of watchers) it will (starting in version `0.9.0`) output (error-level) logs to warn you about any extra triggers and functions.  If you would like to clean these up you can start your application with the `ECTO_WATCH_CLEANUP` environment variable set to `cleanup` and `EctoWatch` will delete any triggers and functions which wouldn't be created by the current watcher configuration.","ref":"notes.html#dealing-with-leftover-postgresql-triggers"},{"type":"extras","title":"Why only send the id and not the full record? - Notes","doc":"The main reason: The `pg_notify` function has a limit of 8000 characters and wasn't created to send full-records on updates.\n\nAlso if many updates are done in quick succession to the same record, subscribers will need to process all of the old results before getting to the newest one.  For example if a LiveView is a subscriber it may get 10 updates about a record to the browser.  If the LiveView has to make a query then it will be more likely to get the latest data.  Since LiveView doesn't send updates when nothing has changed in the view for the user, this will mean less traffic to the browsers.","ref":"notes.html#why-only-send-the-id-and-not-the-full-record"},{"type":"extras","title":"Why not send the values inside of a schema struct? - Notes","doc":"If an application were to take the extra data from an event and pass it to some other part of the app, it may seem like the missing fields were actually missing from the database.  Since the data sent due to `extra_columns` isn't a complete load of the record, it doesn't make sense to send the whole struct.","ref":"notes.html#why-not-send-the-values-inside-of-a-schema-struct"},{"type":"extras","title":"Scaling of queries - Notes","doc":"If you have many processes which are subscribed to updates and each process makes a DB query on receiving the message this could lead to many queries.  You may solve this by creating a GenServer which listens for messages and then makes a single query to the database (e.g. every X milliseconds) to get all the records that need to be updated, passing them on via another `PubSub` message.\n\nThis may be added later as a feature of `EctoWatch`.","ref":"notes.html#scaling-of-queries"},{"type":"extras","title":"Sometimes you may not want updates whenever there's an update from the database - Notes","doc":"If you have a task or a migration that needs to update the database **without** triggering updates in the rest of the application there are a few solutions (see [this StackOverflow question](https://stackoverflow.com/questions/37730870/how-to-disable-postgresql-triggers-in-one-transaction-only).  One solutions is to set `session_replication_role` to `replica` temporarily in a transaction:\n\n```\nBEGIN\nSET session_replication_role = replica;\n-- do changes here --\nSET session_replication_role = DEFAULT;\nCOMMIT\n```\n\nDisabling the triggers can lock the table in a transaction and so should be used with caution.  Disabling the triggers outside of a transaction may cause updates to be missed.","ref":"notes.html#sometimes-you-may-not-want-updates-whenever-there-s-an-update-from-the-database"},{"type":"extras","title":"Upgrading Versions","doc":"As `EctoWatch` is pre-1.0.0, breaking changes may occur in minor versions. This guide is here to help you understand version releases with breaking changes and how to change your code to work with the new version.","ref":"upgrading-versions.html"},{"type":"extras","title":"Upgrading to 0.6.0 - Upgrading Versions","doc":"In this version the broadcast messages from `EctoWatch` changed from a 4-element tuple to a 3-element tuple. Before the primary key value and the `extra_columns` data were two separate elements in the tuple:\n\n```elixir\ndef handle_info({:inserted, Comment, id, %{post_id: post_id}}, socket) do\n  # ...\n```\n\nWith version 0.6.0, they are combined into a single map:\n\n```elixir\ndef handle_info({:inserted, Comment, %{id: id, post_id: post_id}}, socket) do\n  # ...\n```","ref":"upgrading-versions.html#upgrading-to-0-6-0"},{"type":"extras","title":"Upgrading to 0.8.0 - Upgrading Versions","doc":"In this version became is no longer required to specify the update type (`:inserted`/`:updated`/`:deleted`) for watchers with labels.  Before you would have:\n\n```elixir\n# watcher config:\nwatchers: [\n  {Comment, :updated, trigger_columns: [:title, :body], label: :title_or_body_updated},\n\n# subscribe:\nEctoWatch.subscribe(:title_or_body_updated, :updated)\n# or\nEctoWatch.subscribe(:title_or_body_updated, :updated, comment_id)\n# or\nEctoWatch.subscribe(:title_or_body_updated, :updated, {:post_id, post_id})\n\n# handler:\ndef handle_info({:inserted, Comment, %{id: id}}, socket) do\n  # ...\n```\n\nWith versios 0.8.0 the update type is implied by the label, so you can subscribe simply by doing:\n\n```elixir\n# subscribe:\nEctoWatch.subscribe(:title_or_body_updated)\n# or\nEctoWatch.subscribe(:title_or_body_updated, comment_id)\n# or\nEctoWatch.subscribe(:title_or_body_updated, {:post_id, post_id})\n```\n\nAlso, to keep the subscribe function consistent, the normal case of subscribing and handling to a watcher that doesn't have a label requires a tuple of the ecto schema + update type:\n\n```elixir\n# watcher config:\nwatchers: [\n  {Comment, :updated},\n\nEctoWatch.subscribe({Comment, :updated})\n\n# handler (NOTE the flipped order of schema and update type):\ndef handle_info({{Comment, :inserted}, %{id: id}}, socket) do\n  # ...\n```\n\nYou can think of the first argument of `subscribe` or the first element of the tuple as an lookup identifier for the watcher which is either `{ecto_schema(), update_type()}` or a label atom.  So handling a label would just be:\n\n\n```elixir\ndef handle_info({:title_or_body_updated, %{id: id}}, socket) do\n  # ...\n```","ref":"upgrading-versions.html#upgrading-to-0-8-0"},{"type":"extras","title":"Potental TODOs","doc":"* Support features of `CREATE TRIGGER`:\n   * allow specifying a condition for when the trigger should fire\n * Creating a batch-processing GenServer to reduce queries to the database.\n * Make watchers more generic (?).  Don't need dependency on PubSub, but could make it an adapter or something\n * Allow for local broadcasting of Phoenix.PubSub messages\n * Allow customization of messages sent","ref":"potental-todos.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}